Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2696)
@@ -3187,9 +3471,949 @@
             lsf_surf = .FALSE.
         ENDIF
-       
-!--     init anthropogenic sources of heat
-        CALL usm_allocate_urban_surface()
-       
-!--     read the surface_types array somewhere
+
+!
+!--     Flag surface elements belonging to the ground floor level. Therefore, 
+!--     use terrain height array from file, if available. This flag is later used
+!--     to control initialization of surface attributes.
+        surf_usm_h%ground_level = .FALSE. 
+        DO  m = 1, surf_usm_h%ns
+           i = surf_usm_h%i(m)
+           j = surf_usm_h%j(m)
+           k = surf_usm_h%k(m)
+!
+!--        Get local ground level. If no ground level is given in input file,
+!--        use default value.
+           ground_floor_level_l = ground_floor_level
+           IF ( building_pars_f%from_file )  THEN
+              IF ( building_pars_f%pars_xy(ind_gflh,j,i) /=                    &
+                   building_pars_f%fill )  &
+                 ground_floor_level_l = building_pars_f%pars_xy(ind_gflh,j,i)          
+           ENDIF
+!
+!--        Determine height of surface element above ground level
+           IF (  terrain_height_f%from_file )  THEN
+              z_agl = zw(k) - terrain_height_f%var(j,i)
+           ELSE
+              z_agl = zw(k)
+           ENDIF
+!
+!--        Set flag for ground level
+           IF ( z_agl <= ground_floor_level_l )                                &
+              surf_usm_h%ground_level(m) = .TRUE.
+        ENDDO
+
+        DO  l = 0, 3
+           surf_usm_v(l)%ground_level = .FALSE.
+           DO  m = 1, surf_usm_v(l)%ns
+              i = surf_usm_v(l)%i(m) + surf_usm_v(l)%ioff
+              j = surf_usm_v(l)%j(m) + surf_usm_v(l)%joff
+              k = surf_usm_v(l)%k(m)
+!
+!--           Get local ground level. If no ground level is given in input file,
+!--           use default value.
+              ground_floor_level_l = ground_floor_level
+              IF ( building_pars_f%from_file )  THEN
+                 IF ( building_pars_f%pars_xy(ind_gflh,j,i) /=                 &
+                      building_pars_f%fill ) &
+                    ground_floor_level_l = building_pars_f%pars_xy(ind_gflh,j,i)
+              ENDIF
+!
+!--           Determine height of surface element above ground level. Please 
+!--           note, height of surface element is determined with respect to
+!--           its height of the adjoing atmospheric grid point. 
+              IF (  terrain_height_f%from_file )  THEN
+                 z_agl = zw(k) - terrain_height_f%var(j-surf_usm_v(l)%joff,    &
+                                                      i-surf_usm_v(l)%ioff)
+              ELSE
+                 z_agl = zw(k)
+              ENDIF
+!
+!--           Set flag for ground level
+              IF ( z_agl <= ground_floor_level_l )                                &
+                 surf_usm_v(l)%ground_level(m) = .TRUE.
+
+           ENDDO
+        ENDDO
+!
+!--     Initialize urban-type surface attribute. According to initialization in 
+!--     land-surface model, follow a 3-level approach.
+!--     Level 1 - initialization via default attributes 
+        DO  m = 1, surf_usm_h%ns
+!
+!--        Now, all horizontal surfaces are roof surfaces (?)
+           surf_usm_h%isroof_surf(m)   = .TRUE.
+           surf_usm_h%surface_types(m) = roof_category         !< default category for root surface
+!
+!--        In order to distinguish between ground floor level and 
+!--        above-ground-floor level surfaces, set input indices. 
+           ind_wall_frac    = MERGE( ind_wall_frac_gfl,    ind_wall_frac_agfl,    &
+                                     surf_usm_h%ground_level(m) )
+           ind_win_frac     = MERGE( ind_win_frac_gfl,     ind_win_frac_agfl,     &
+                                     surf_usm_h%ground_level(m) )
+           ind_green_frac_w = MERGE( ind_green_frac_w_gfl, ind_green_frac_w_agfl, &
+                                     surf_usm_h%ground_level(m) )
+           ind_green_frac_r = MERGE( ind_green_frac_r_gfl, ind_green_frac_r_agfl, &
+                                     surf_usm_h%ground_level(m) )
+           ind_lai_r        = MERGE( ind_lai_r_gfl,        ind_lai_r_agfl,        &
+                                     surf_usm_h%ground_level(m) )
+           ind_lai_w        = MERGE( ind_lai_w_gfl,        ind_lai_w_agfl,        &
+                                     surf_usm_h%ground_level(m) )
+           ind_hc1          = MERGE( ind_hc1_gfl,          ind_hc1_agfl,          &
+                                     surf_usm_h%ground_level(m) )
+           ind_hc2          = MERGE( ind_hc2_gfl,          ind_hc2_agfl,          &
+                                     surf_usm_h%ground_level(m) )
+           ind_hc3          = MERGE( ind_hc3_gfl,          ind_hc3_agfl,          &
+                                     surf_usm_h%ground_level(m) )
+           ind_tc1          = MERGE( ind_tc1_gfl,          ind_tc1_agfl,          &
+                                     surf_usm_h%ground_level(m) )
+           ind_tc2          = MERGE( ind_tc2_gfl,          ind_tc2_agfl,          &
+                                     surf_usm_h%ground_level(m) )
+           ind_tc3          = MERGE( ind_tc3_gfl,          ind_tc3_agfl,          &
+                                     surf_usm_h%ground_level(m) )
+           ind_emis_wall    = MERGE( ind_emis_wall_gfl,    ind_emis_wall_agfl,    &
+                                     surf_usm_h%ground_level(m) )
+           ind_emis_green   = MERGE( ind_emis_green_gfl,   ind_emis_green_agfl,   &
+                                     surf_usm_h%ground_level(m) )
+           ind_emis_win     = MERGE( ind_emis_win_gfl,     ind_emis_win_agfl,     &
+                                     surf_usm_h%ground_level(m) )
+           ind_trans        = MERGE( ind_trans_gfl,        ind_trans_agfl,        &
+                                     surf_usm_h%ground_level(m) )
+           ind_z0           = MERGE( ind_z0_gfl,           ind_z0_agfl,           &
+                                     surf_usm_h%ground_level(m) )
+           ind_z0qh         = MERGE( ind_z0qh_gfl,         ind_z0qh_agfl,         &
+                                     surf_usm_h%ground_level(m) )
+!
+!--        Initialize relatvie wall- (0), green- (1) and window (2) fractions
+           surf_usm_h%frac(0,m)  = building_pars(ind_wall_frac,building_type)   
+           surf_usm_h%frac(1,m)  = building_pars(ind_green_frac_r,building_type)  
+           surf_usm_h%frac(2,m)  = building_pars(ind_win_frac,building_type)  
+           surf_usm_h%lai(m)     = building_pars(ind_green_frac_r,building_type)  
+
+           surf_usm_h%rho_c_wall(nzb_wall,m)   = building_pars(ind_hc1,building_type)  
+           surf_usm_h%rho_c_wall(nzb_wall+1,m) = building_pars(ind_hc1,building_type)
+           surf_usm_h%rho_c_wall(nzb_wall+2,m) = building_pars(ind_hc2,building_type)
+           surf_usm_h%rho_c_wall(nzb_wall+3,m) = building_pars(ind_hc3,building_type)    
+           surf_usm_h%lambda_h(nzb_wall,m)   = building_pars(ind_tc1,building_type)  
+           surf_usm_h%lambda_h(nzb_wall+1,m) = building_pars(ind_tc1,building_type) 
+           surf_usm_h%lambda_h(nzb_wall+2,m) = building_pars(ind_tc2,building_type)
+           surf_usm_h%lambda_h(nzb_wall+3,m) = building_pars(ind_tc3,building_type)    
+           surf_usm_h%rho_c_green(nzb_wall,m)   = building_pars(ind_hc1,building_type)  
+           surf_usm_h%rho_c_green(nzb_wall+1,m) = building_pars(ind_hc1,building_type)
+           surf_usm_h%rho_c_green(nzb_wall+2,m) = building_pars(ind_hc2,building_type)
+           surf_usm_h%rho_c_green(nzb_wall+3,m) = building_pars(ind_hc3,building_type)    
+           surf_usm_h%lambda_h_green(nzb_wall,m)   = building_pars(ind_tc1,building_type)  
+           surf_usm_h%lambda_h_green(nzb_wall+1,m) = building_pars(ind_tc1,building_type) 
+           surf_usm_h%lambda_h_green(nzb_wall+2,m) = building_pars(ind_tc2,building_type)
+           surf_usm_h%lambda_h_green(nzb_wall+3,m) = building_pars(ind_tc3,building_type)
+           surf_usm_h%rho_c_window(nzb_wall,m)   = building_pars(ind_hc1,building_type)  
+           surf_usm_h%rho_c_window(nzb_wall+1,m) = building_pars(ind_hc1,building_type)
+           surf_usm_h%rho_c_window(nzb_wall+2,m) = building_pars(ind_hc2,building_type)
+           surf_usm_h%rho_c_window(nzb_wall+3,m) = building_pars(ind_hc3,building_type)    
+           surf_usm_h%lambda_h_window(nzb_wall,m)   = building_pars(ind_tc1,building_type)  
+           surf_usm_h%lambda_h_window(nzb_wall+1,m) = building_pars(ind_tc1,building_type) 
+           surf_usm_h%lambda_h_window(nzb_wall+2,m) = building_pars(ind_tc2,building_type)
+           surf_usm_h%lambda_h_window(nzb_wall+3,m) = building_pars(ind_tc3,building_type)    
+
+           surf_usm_h%target_temp_summer(m)  = building_pars(12,building_type)    
+           surf_usm_h%target_temp_winter(m)  = building_pars(13,building_type)    
+!
+!--        emissivity of wall-, green- and window fraction 
+           surf_usm_h%emissivity(0,m)        = building_pars(ind_emis_wall,building_type)
+           surf_usm_h%emissivity(1,m)        = building_pars(ind_emis_green,building_type)
+           surf_usm_h%emissivity(2,m)        = building_pars(ind_emis_win,building_type)
+
+           surf_usm_h%transmissivity(m)      = building_pars(ind_trans,building_type)
+
+           surf_usm_h%z0(m)                  = building_pars(ind_z0,building_type)
+           surf_usm_h%z0h(m)                 = building_pars(ind_z0qh,building_type)
+           surf_usm_h%z0q(m)                 = building_pars(ind_z0qh,building_type)
+!
+!--        albedo type for wall fraction, green fraction, window fraction
+           surf_usm_h%albedo_type(0,m)       = INT( building_pars(ind_alb_wall,building_type)  )
+           surf_usm_h%albedo_type(1,m)       = INT( building_pars(ind_alb_green,building_type) )
+           surf_usm_h%albedo_type(2,m)       = INT( building_pars(ind_alb_win,building_type)   )
+
+           surf_usm_h%zw(nzb_wall,m)         = building_pars(ind_thick_1,building_type)
+           surf_usm_h%zw(nzb_wall+1,m)       = building_pars(ind_thick_2,building_type)
+           surf_usm_h%zw(nzb_wall+2,m)       = building_pars(ind_thick_3,building_type)
+           surf_usm_h%zw(nzb_wall+3,m)       = building_pars(ind_thick_4,building_type)
+           
+           surf_usm_h%zw_green(nzb_wall,m)         = building_pars(ind_thick_1,building_type)
+           surf_usm_h%zw_green(nzb_wall+1,m)       = building_pars(ind_thick_2,building_type)
+           surf_usm_h%zw_green(nzb_wall+2,m)       = building_pars(ind_thick_3,building_type)
+           surf_usm_h%zw_green(nzb_wall+3,m)       = building_pars(ind_thick_4,building_type)
+           
+           surf_usm_h%zw_window(nzb_wall,m)         = building_pars(ind_thick_1,building_type)
+           surf_usm_h%zw_window(nzb_wall+1,m)       = building_pars(ind_thick_2,building_type)
+           surf_usm_h%zw_window(nzb_wall+2,m)       = building_pars(ind_thick_3,building_type)
+           surf_usm_h%zw_window(nzb_wall+3,m)       = building_pars(ind_thick_4,building_type)
+
+           surf_usm_h%c_surface(m)           = building_pars(45,building_type)  
+           surf_usm_h%lambda_surf(m)         = building_pars(46,building_type)  
+           surf_usm_h%c_surface_green(m)     = building_pars(45,building_type)  
+           surf_usm_h%lambda_surf_green(m)   = building_pars(46,building_type)  
+           surf_usm_h%c_surface_window(m)    = building_pars(45,building_type)  
+           surf_usm_h%lambda_surf_window(m)  = building_pars(46,building_type)  
+
+        ENDDO
+
+        DO  l = 0, 3
+           DO  m = 1, surf_usm_v(l)%ns
+
+              surf_usm_v(l)%surface_types(m) = wall_category         !< default category for root surface
+!
+!--           In order to distinguish between ground floor level and 
+!--           above-ground-floor level surfaces, set input indices. 
+              ind_wall_frac    = MERGE( ind_wall_frac_gfl,    ind_wall_frac_agfl,    &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_win_frac     = MERGE( ind_win_frac_gfl,     ind_win_frac_agfl,     &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_green_frac_w = MERGE( ind_green_frac_w_gfl, ind_green_frac_w_agfl, &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_green_frac_r = MERGE( ind_green_frac_r_gfl, ind_green_frac_r_agfl, &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_lai_r        = MERGE( ind_lai_r_gfl,        ind_lai_r_agfl,        &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_lai_w        = MERGE( ind_lai_w_gfl,        ind_lai_w_agfl,        &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_hc1          = MERGE( ind_hc1_gfl,          ind_hc1_agfl,          &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_hc2          = MERGE( ind_hc2_gfl,          ind_hc2_agfl,          &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_hc3          = MERGE( ind_hc3_gfl,          ind_hc3_agfl,          &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_tc1          = MERGE( ind_tc1_gfl,          ind_tc1_agfl,          &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_tc2          = MERGE( ind_tc2_gfl,          ind_tc2_agfl,          &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_tc3          = MERGE( ind_tc3_gfl,          ind_tc3_agfl,          &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_emis_wall    = MERGE( ind_emis_wall_gfl,    ind_emis_wall_agfl,    &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_emis_green   = MERGE( ind_emis_green_gfl,   ind_emis_green_agfl,   &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_emis_win     = MERGE( ind_emis_win_gfl,     ind_emis_win_agfl,     &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_trans        = MERGE( ind_trans_gfl,       ind_trans_agfl,         &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_z0           = MERGE( ind_z0_gfl,           ind_z0_agfl,           &
+                                        surf_usm_v(l)%ground_level(m) )
+              ind_z0qh         = MERGE( ind_z0qh_gfl,         ind_z0qh_agfl,         &
+                                        surf_usm_v(l)%ground_level(m) )
+
+!
+!--           Initialize relatvie wall- (0), green- (1) and window (2) fractions
+              surf_usm_v(l)%frac(0,m)              = building_pars(ind_wall_frac,building_type)   
+              surf_usm_v(l)%frac(1,m)              = building_pars(ind_green_frac_w,building_type) 
+              surf_usm_v(l)%frac(2,m)              = building_pars(ind_win_frac,building_type)  
+              surf_usm_v(l)%lai(m)                 = building_pars(ind_lai_w,building_type)  
+
+              surf_usm_v(l)%rho_c_wall(nzb_wall,m)   = building_pars(ind_hc1,building_type)  
+              surf_usm_v(l)%rho_c_wall(nzb_wall+1,m) = building_pars(ind_hc1,building_type)
+              surf_usm_v(l)%rho_c_wall(nzb_wall+2,m) = building_pars(ind_hc2,building_type)
+              surf_usm_v(l)%rho_c_wall(nzb_wall+3,m) = building_pars(ind_hc3,building_type)    
+              
+              surf_usm_v(l)%rho_c_green(nzb_wall,m)   = building_pars(ind_hc1,building_type)  
+              surf_usm_v(l)%rho_c_green(nzb_wall+1,m) = building_pars(ind_hc1,building_type)
+              surf_usm_v(l)%rho_c_green(nzb_wall+2,m) = building_pars(ind_hc2,building_type)
+              surf_usm_v(l)%rho_c_green(nzb_wall+3,m) = building_pars(ind_hc3,building_type)    
+              
+              surf_usm_v(l)%rho_c_window(nzb_wall,m)   = building_pars(ind_hc1,building_type)  
+              surf_usm_v(l)%rho_c_window(nzb_wall+1,m) = building_pars(ind_hc1,building_type)
+              surf_usm_v(l)%rho_c_window(nzb_wall+2,m) = building_pars(ind_hc2,building_type)
+              surf_usm_v(l)%rho_c_window(nzb_wall+3,m) = building_pars(ind_hc3,building_type)    
+
+              surf_usm_v(l)%lambda_h(nzb_wall,m)   = building_pars(ind_tc1,building_type)  
+              surf_usm_v(l)%lambda_h(nzb_wall+1,m) = building_pars(ind_tc1,building_type) 
+              surf_usm_v(l)%lambda_h(nzb_wall+2,m) = building_pars(ind_tc2,building_type)
+              surf_usm_v(l)%lambda_h(nzb_wall+3,m) = building_pars(ind_tc3,building_type)    
+              
+              surf_usm_v(l)%lambda_h_green(nzb_wall,m)   = building_pars(ind_tc1,building_type)  
+              surf_usm_v(l)%lambda_h_green(nzb_wall+1,m) = building_pars(ind_tc1,building_type) 
+              surf_usm_v(l)%lambda_h_green(nzb_wall+2,m) = building_pars(ind_tc2,building_type)
+              surf_usm_v(l)%lambda_h_green(nzb_wall+3,m) = building_pars(ind_tc3,building_type)    
+
+              surf_usm_v(l)%lambda_h_window(nzb_wall,m)   = building_pars(ind_tc1,building_type)  
+              surf_usm_v(l)%lambda_h_window(nzb_wall+1,m) = building_pars(ind_tc1,building_type) 
+              surf_usm_v(l)%lambda_h_window(nzb_wall+2,m) = building_pars(ind_tc2,building_type)
+              surf_usm_v(l)%lambda_h_window(nzb_wall+3,m) = building_pars(ind_tc3,building_type)    
+
+              surf_usm_v(l)%target_temp_summer(m)  = building_pars(12,building_type)    
+              surf_usm_v(l)%target_temp_winter(m)  = building_pars(13,building_type)    
+!
+!--           emissivity of wall-, green- and window fraction 
+              surf_usm_v(l)%emissivity(0,m)        = building_pars(ind_emis_wall,building_type)
+              surf_usm_v(l)%emissivity(1,m)        = building_pars(ind_emis_green,building_type)
+              surf_usm_v(l)%emissivity(2,m)        = building_pars(ind_emis_win,building_type)
+
+              surf_usm_v(l)%transmissivity(m)      = building_pars(ind_trans,building_type)
+
+              surf_usm_v(l)%z0(m)                  = building_pars(ind_z0,building_type)
+              surf_usm_v(l)%z0h(m)                 = building_pars(ind_z0qh,building_type)
+              surf_usm_v(l)%z0q(m)                 = building_pars(ind_z0qh,building_type)
+
+              surf_usm_v(l)%albedo_type(0,m)       = INT( building_pars(ind_alb_wall,building_type) )
+              surf_usm_v(l)%albedo_type(1,m)       = INT( building_pars(ind_alb_green,building_type) )
+              surf_usm_v(l)%albedo_type(2,m)       = INT( building_pars(ind_alb_win,building_type) )
+
+              surf_usm_v(l)%zw(nzb_wall,m)         = building_pars(ind_thick_1,building_type)
+              surf_usm_v(l)%zw(nzb_wall+1,m)       = building_pars(ind_thick_2,building_type)
+              surf_usm_v(l)%zw(nzb_wall+2,m)       = building_pars(ind_thick_3,building_type)
+              surf_usm_v(l)%zw(nzb_wall+3,m)       = building_pars(ind_thick_4,building_type)
+              
+              surf_usm_v(l)%zw_green(nzb_wall,m)         = building_pars(ind_thick_1,building_type)
+              surf_usm_v(l)%zw_green(nzb_wall+1,m)       = building_pars(ind_thick_2,building_type)
+              surf_usm_v(l)%zw_green(nzb_wall+2,m)       = building_pars(ind_thick_3,building_type)
+              surf_usm_v(l)%zw_green(nzb_wall+3,m)       = building_pars(ind_thick_4,building_type)
+
+              surf_usm_v(l)%zw_window(nzb_wall,m)         = building_pars(ind_thick_1,building_type)
+              surf_usm_v(l)%zw_window(nzb_wall+1,m)       = building_pars(ind_thick_2,building_type)
+              surf_usm_v(l)%zw_window(nzb_wall+2,m)       = building_pars(ind_thick_3,building_type)
+              surf_usm_v(l)%zw_window(nzb_wall+3,m)       = building_pars(ind_thick_4,building_type)
+
+              surf_usm_v(l)%c_surface(m)           = building_pars(45,building_type)  
+              surf_usm_v(l)%lambda_surf(m)         = building_pars(46,building_type)
+              surf_usm_v(l)%c_surface_green(m)     = building_pars(45,building_type)  
+              surf_usm_v(l)%lambda_surf_green(m)   = building_pars(46,building_type)
+              surf_usm_v(l)%c_surface_window(m)    = building_pars(45,building_type)  
+              surf_usm_v(l)%lambda_surf_window(m)  = building_pars(46,building_type)
+
+           ENDDO
+        ENDDO
+!
+!--     Level 2 - initialization via building type read from file
+        IF ( building_type_f%from_file )  THEN
+           DO  m = 1, surf_usm_h%ns
+              i = surf_usm_h%i(m)
+              j = surf_usm_h%j(m)
+!
+!--           For the moment, limit building type to 6 (to overcome errors in input file).
+              st = building_type_f%var(j,i)
+              IF ( st /= building_type_f%fill )  THEN
+
+!
+!--              In order to distinguish between ground floor level and 
+!--              above-ground-floor level surfaces, set input indices. 
+                 ind_wall_frac    = MERGE( ind_wall_frac_gfl,    ind_wall_frac_agfl,    &
+                                           surf_usm_h%ground_level(m) )
+                 ind_win_frac     = MERGE( ind_win_frac_gfl,     ind_win_frac_agfl,     &
+                                           surf_usm_h%ground_level(m) )
+                 ind_green_frac_w = MERGE( ind_green_frac_w_gfl, ind_green_frac_w_agfl, &
+                                           surf_usm_h%ground_level(m) )
+                 ind_green_frac_r = MERGE( ind_green_frac_r_gfl, ind_green_frac_r_agfl, &
+                                           surf_usm_h%ground_level(m) )
+                 ind_lai_r        = MERGE( ind_lai_r_gfl,        ind_lai_r_agfl,        &
+                                           surf_usm_h%ground_level(m) )
+                 ind_lai_w        = MERGE( ind_lai_w_gfl,        ind_lai_w_agfl,        &
+                                           surf_usm_h%ground_level(m) )
+                 ind_hc1          = MERGE( ind_hc1_gfl,          ind_hc1_agfl,          &
+                                           surf_usm_h%ground_level(m) )
+                 ind_hc2          = MERGE( ind_hc2_gfl,          ind_hc2_agfl,          &
+                                           surf_usm_h%ground_level(m) )
+                 ind_hc3          = MERGE( ind_hc3_gfl,          ind_hc3_agfl,          &
+                                           surf_usm_h%ground_level(m) )
+                 ind_tc1          = MERGE( ind_tc1_gfl,          ind_tc1_agfl,          &
+                                           surf_usm_h%ground_level(m) )
+                 ind_tc2          = MERGE( ind_tc2_gfl,          ind_tc2_agfl,          &
+                                           surf_usm_h%ground_level(m) )
+                 ind_tc3          = MERGE( ind_tc3_gfl,          ind_tc3_agfl,          &
+                                           surf_usm_h%ground_level(m) )
+                 ind_emis_wall    = MERGE( ind_emis_wall_gfl,    ind_emis_wall_agfl,    &
+                                           surf_usm_h%ground_level(m) )
+                 ind_emis_green   = MERGE( ind_emis_green_gfl,   ind_emis_green_agfl,   &
+                                           surf_usm_h%ground_level(m) )
+                 ind_emis_win     = MERGE( ind_emis_win_gfl,     ind_emis_win_agfl,     &
+                                           surf_usm_h%ground_level(m) )
+                 ind_trans        = MERGE( ind_trans_gfl,        ind_trans_agfl,        &
+                                           surf_usm_h%ground_level(m) )
+                 ind_z0           = MERGE( ind_z0_gfl,           ind_z0_agfl,           &
+                                           surf_usm_h%ground_level(m) )
+                 ind_z0qh         = MERGE( ind_z0qh_gfl,         ind_z0qh_agfl,         &
+                                           surf_usm_h%ground_level(m) )
+
+!
+!--              Initialize relatvie wall- (0), green- (1) and window (2) fractions
+                 surf_usm_h%frac(0,m)   = building_pars(ind_wall_frac,st)   
+                 surf_usm_h%frac(1,m)   = building_pars(ind_green_frac_r,st)  
+                 surf_usm_h%frac(2,m)   = building_pars(ind_win_frac,st)  
+                 surf_usm_h%lai(m)      = building_pars(ind_green_frac_r,st)  
+
+                 surf_usm_h%rho_c_wall(nzb_wall,m)   = building_pars(ind_hc1,st)  
+                 surf_usm_h%rho_c_wall(nzb_wall+1,m) = building_pars(ind_hc1,st)
+                 surf_usm_h%rho_c_wall(nzb_wall+2,m) = building_pars(ind_hc2,st)
+                 surf_usm_h%rho_c_wall(nzb_wall+3,m) = building_pars(ind_hc3,st)    
+                 surf_usm_h%lambda_h(nzb_wall,m)   = building_pars(ind_tc1,st)  
+                 surf_usm_h%lambda_h(nzb_wall+1,m) = building_pars(ind_tc1,st) 
+                 surf_usm_h%lambda_h(nzb_wall+2,m) = building_pars(ind_tc2,st)
+                 surf_usm_h%lambda_h(nzb_wall+3,m) = building_pars(ind_tc3,st)    
+                 
+                 surf_usm_h%rho_c_green(nzb_wall,m)   = building_pars(ind_hc1,st)  
+                 surf_usm_h%rho_c_green(nzb_wall+1,m) = building_pars(ind_hc1,st)
+                 surf_usm_h%rho_c_green(nzb_wall+2,m) = building_pars(ind_hc2,st)
+                 surf_usm_h%rho_c_green(nzb_wall+3,m) = building_pars(ind_hc3,st)    
+                 surf_usm_h%lambda_h_green(nzb_wall,m)   = building_pars(ind_tc1,st)  
+                 surf_usm_h%lambda_h_green(nzb_wall+1,m) = building_pars(ind_tc1,st) 
+                 surf_usm_h%lambda_h_green(nzb_wall+2,m) = building_pars(ind_tc2,st)
+                 surf_usm_h%lambda_h_green(nzb_wall+3,m) = building_pars(ind_tc3,st)    
+                
+                 surf_usm_h%rho_c_window(nzb_wall,m)   = building_pars(ind_hc1,st)  
+                 surf_usm_h%rho_c_window(nzb_wall+1,m) = building_pars(ind_hc1,st)
+                 surf_usm_h%rho_c_window(nzb_wall+2,m) = building_pars(ind_hc2,st)
+                 surf_usm_h%rho_c_window(nzb_wall+3,m) = building_pars(ind_hc3,st)    
+                 surf_usm_h%lambda_h_window(nzb_wall,m)   = building_pars(ind_tc1,st)  
+                 surf_usm_h%lambda_h_window(nzb_wall+1,m) = building_pars(ind_tc1,st) 
+                 surf_usm_h%lambda_h_window(nzb_wall+2,m) = building_pars(ind_tc2,st)
+                 surf_usm_h%lambda_h_window(nzb_wall+3,m) = building_pars(ind_tc3,st)    
+
+                 surf_usm_h%target_temp_summer(m)  = building_pars(12,st)    
+                 surf_usm_h%target_temp_winter(m)  = building_pars(13,st)    
+!
+!--              emissivity of wall-, green- and window fraction 
+                 surf_usm_h%emissivity(0,m)        = building_pars(ind_emis_wall,st)
+                 surf_usm_h%emissivity(1,m)        = building_pars(ind_emis_green,st)
+                 surf_usm_h%emissivity(2,m)        = building_pars(ind_emis_win,st)
+
+                 surf_usm_h%transmissivity(m)      = building_pars(ind_trans,st)
+
+                 surf_usm_h%z0(m)                  = building_pars(ind_z0,st)
+                 surf_usm_h%z0h(m)                 = building_pars(ind_z0qh,st)
+                 surf_usm_h%z0q(m)                 = building_pars(ind_z0qh,st)
+!
+!--              albedo type for wall fraction, green fraction, window fraction
+                 surf_usm_h%albedo_type(0,m)       = INT( building_pars(ind_alb_wall,st) )
+                 surf_usm_h%albedo_type(1,m)       = INT( building_pars(ind_alb_green,st) )
+                 surf_usm_h%albedo_type(2,m)       = INT( building_pars(ind_alb_win,st) )
+
+                 surf_usm_h%zw(nzb_wall,m)         = building_pars(ind_thick_1,st)
+                 surf_usm_h%zw(nzb_wall+1,m)       = building_pars(ind_thick_2,st)
+                 surf_usm_h%zw(nzb_wall+2,m)       = building_pars(ind_thick_3,st)
+                 surf_usm_h%zw(nzb_wall+3,m)       = building_pars(ind_thick_4,st)
+                 
+                 surf_usm_h%zw_green(nzb_wall,m)         = building_pars(ind_thick_1,st)
+                 surf_usm_h%zw_green(nzb_wall+1,m)       = building_pars(ind_thick_2,st)
+                 surf_usm_h%zw_green(nzb_wall+2,m)       = building_pars(ind_thick_3,st)
+                 surf_usm_h%zw_green(nzb_wall+3,m)       = building_pars(ind_thick_4,st)
+
+                 surf_usm_h%zw_window(nzb_wall,m)         = building_pars(ind_thick_1,st)
+                 surf_usm_h%zw_window(nzb_wall+1,m)       = building_pars(ind_thick_2,st)
+                 surf_usm_h%zw_window(nzb_wall+2,m)       = building_pars(ind_thick_3,st)
+                 surf_usm_h%zw_window(nzb_wall+3,m)       = building_pars(ind_thick_4,st)
+
+                 surf_usm_h%c_surface(m)           = building_pars(45,st)  
+                 surf_usm_h%lambda_surf(m)         = building_pars(46,st)
+                 surf_usm_h%c_surface_green(m)     = building_pars(45,st)  
+                 surf_usm_h%lambda_surf_green(m)   = building_pars(46,st)
+                 surf_usm_h%c_surface_window(m)    = building_pars(45,st)  
+                 surf_usm_h%lambda_surf_window(m)  = building_pars(46,st)
+
+              ENDIF
+           ENDDO
+
+           DO  l = 0, 3
+              DO  m = 1, surf_usm_v(l)%ns
+                 i = surf_usm_v(l)%i(m) + surf_usm_v(l)%ioff
+                 j = surf_usm_v(l)%j(m) + surf_usm_v(l)%joff
+!
+!--              For the moment, limit building type to 6 (to overcome errors in input file).
+
+                 st = building_type_f%var(j,i)
+                 IF ( st /= building_type_f%fill )  THEN
+
+!
+!--                 In order to distinguish between ground floor level and 
+!--                 above-ground-floor level surfaces, set input indices. 
+                    ind_wall_frac    = MERGE( ind_wall_frac_gfl,    ind_wall_frac_agfl,    &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_win_frac     = MERGE( ind_win_frac_gfl,     ind_win_frac_agfl,     &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_green_frac_w = MERGE( ind_green_frac_w_gfl, ind_green_frac_w_agfl, &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_green_frac_r = MERGE( ind_green_frac_r_gfl, ind_green_frac_r_agfl, &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_lai_r        = MERGE( ind_lai_r_gfl,        ind_lai_r_agfl,        &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_lai_w        = MERGE( ind_lai_w_gfl,        ind_lai_w_agfl,        &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_hc1          = MERGE( ind_hc1_gfl,          ind_hc1_agfl,          &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_hc2          = MERGE( ind_hc2_gfl,          ind_hc2_agfl,          &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_hc3          = MERGE( ind_hc3_gfl,          ind_hc3_agfl,          &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_tc1          = MERGE( ind_tc1_gfl,          ind_tc1_agfl,          &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_tc2          = MERGE( ind_tc2_gfl,          ind_tc2_agfl,          &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_tc3          = MERGE( ind_tc3_gfl,          ind_tc3_agfl,          &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_emis_wall    = MERGE( ind_emis_wall_gfl,    ind_emis_wall_agfl,    &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_emis_green   = MERGE( ind_emis_green_gfl,   ind_emis_green_agfl,   &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_emis_win     = MERGE( ind_emis_win_gfl,     ind_emis_win_agfl,     &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_trans        = MERGE( ind_trans_gfl,       ind_trans_agfl,         &
+                                        surf_usm_v(l)%ground_level(m) )
+                    ind_z0           = MERGE( ind_z0_gfl,           ind_z0_agfl,           &
+                                              surf_usm_v(l)%ground_level(m) )
+                    ind_z0qh         = MERGE( ind_z0qh_gfl,         ind_z0qh_agfl,         &
+                                              surf_usm_v(l)%ground_level(m) )
+
+!
+!--                 Initialize relatvie wall- (0), green- (1) and window (2) fractions
+                    surf_usm_v(l)%frac(0,m) = building_pars(ind_wall_frac,st)   
+                    surf_usm_v(l)%frac(1,m) = building_pars(ind_green_frac_w,st)  
+                    surf_usm_v(l)%frac(2,m) = building_pars(ind_win_frac,st)   
+                    surf_usm_v(l)%lai(m)    = building_pars(ind_lai_w,st)  
+
+                    surf_usm_v(l)%rho_c_wall(nzb_wall,m)   = building_pars(ind_hc1,st)  
+                    surf_usm_v(l)%rho_c_wall(nzb_wall+1,m) = building_pars(ind_hc1,st)
+                    surf_usm_v(l)%rho_c_wall(nzb_wall+2,m) = building_pars(ind_hc2,st)
+                    surf_usm_v(l)%rho_c_wall(nzb_wall+3,m) = building_pars(ind_hc3,st)
+                    
+                    surf_usm_v(l)%rho_c_green(nzb_wall,m)   = building_pars(ind_hc1,st)  
+                    surf_usm_v(l)%rho_c_green(nzb_wall+1,m) = building_pars(ind_hc1,st)
+                    surf_usm_v(l)%rho_c_green(nzb_wall+2,m) = building_pars(ind_hc2,st)
+                    surf_usm_v(l)%rho_c_green(nzb_wall+3,m) = building_pars(ind_hc3,st)
+                    
+                    surf_usm_v(l)%rho_c_window(nzb_wall,m)   = building_pars(ind_hc1,st)  
+                    surf_usm_v(l)%rho_c_window(nzb_wall+1,m) = building_pars(ind_hc1,st)
+                    surf_usm_v(l)%rho_c_window(nzb_wall+2,m) = building_pars(ind_hc2,st)
+                    surf_usm_v(l)%rho_c_window(nzb_wall+3,m) = building_pars(ind_hc3,st)
+
+                    surf_usm_v(l)%lambda_h(nzb_wall,m)   = building_pars(ind_tc1,st)  
+                    surf_usm_v(l)%lambda_h(nzb_wall+1,m) = building_pars(ind_tc1,st) 
+                    surf_usm_v(l)%lambda_h(nzb_wall+2,m) = building_pars(ind_tc2,st)
+                    surf_usm_v(l)%lambda_h(nzb_wall+3,m) = building_pars(ind_tc3,st) 
+                    
+                    surf_usm_v(l)%lambda_h_green(nzb_wall,m)   = building_pars(ind_tc1,st)  
+                    surf_usm_v(l)%lambda_h_green(nzb_wall+1,m) = building_pars(ind_tc1,st) 
+                    surf_usm_v(l)%lambda_h_green(nzb_wall+2,m) = building_pars(ind_tc2,st)
+                    surf_usm_v(l)%lambda_h_green(nzb_wall+3,m) = building_pars(ind_tc3,st) 
+                    
+                    surf_usm_v(l)%lambda_h_window(nzb_wall,m)   = building_pars(ind_tc1,st)  
+                    surf_usm_v(l)%lambda_h_window(nzb_wall+1,m) = building_pars(ind_tc1,st) 
+                    surf_usm_v(l)%lambda_h_window(nzb_wall+2,m) = building_pars(ind_tc2,st)
+                    surf_usm_v(l)%lambda_h_window(nzb_wall+3,m) = building_pars(ind_tc3,st) 
+
+                    surf_usm_v(l)%target_temp_summer(m)  = building_pars(12,st)    
+                    surf_usm_v(l)%target_temp_winter(m)  = building_pars(13,st)    
+!
+!--                 emissivity of wall-, green- and window fraction 
+                    surf_usm_v(l)%emissivity(0,m)        = building_pars(ind_emis_wall,st)
+                    surf_usm_v(l)%emissivity(1,m)        = building_pars(ind_emis_green,st)
+                    surf_usm_v(l)%emissivity(2,m)        = building_pars(ind_emis_win,st)
+
+                    surf_usm_v(l)%transmissivity(m)      = building_pars(ind_trans,st)
+
+                    surf_usm_v(l)%z0(m)                  = building_pars(ind_z0,st)
+                    surf_usm_v(l)%z0h(m)                 = building_pars(ind_z0qh,st)
+                    surf_usm_v(l)%z0q(m)                 = building_pars(ind_z0qh,st)
+
+                    surf_usm_v(l)%albedo_type(0,m)       = INT( building_pars(ind_alb_wall,st) )
+                    surf_usm_v(l)%albedo_type(1,m)       = INT( building_pars(ind_alb_green,st) )
+                    surf_usm_v(l)%albedo_type(2,m)       = INT( building_pars(ind_alb_win,st) )
+
+                    surf_usm_v(l)%zw(nzb_wall,m)         = building_pars(ind_thick_1,st)
+                    surf_usm_v(l)%zw(nzb_wall+1,m)       = building_pars(ind_thick_2,st)
+                    surf_usm_v(l)%zw(nzb_wall+2,m)       = building_pars(ind_thick_3,st)
+                    surf_usm_v(l)%zw(nzb_wall+3,m)       = building_pars(ind_thick_4,st)
+                    
+                    surf_usm_v(l)%zw_green(nzb_wall,m)         = building_pars(ind_thick_1,st)
+                    surf_usm_v(l)%zw_green(nzb_wall+1,m)       = building_pars(ind_thick_2,st)
+                    surf_usm_v(l)%zw_green(nzb_wall+2,m)       = building_pars(ind_thick_3,st)
+                    surf_usm_v(l)%zw_green(nzb_wall+3,m)       = building_pars(ind_thick_4,st)
+                    
+                    surf_usm_v(l)%zw_window(nzb_wall,m)         = building_pars(ind_thick_1,st)
+                    surf_usm_v(l)%zw_window(nzb_wall+1,m)       = building_pars(ind_thick_2,st)
+                    surf_usm_v(l)%zw_window(nzb_wall+2,m)       = building_pars(ind_thick_3,st)
+                    surf_usm_v(l)%zw_window(nzb_wall+3,m)       = building_pars(ind_thick_4,st)
+
+                    surf_usm_v(l)%c_surface(m)           = building_pars(45,st)  
+                    surf_usm_v(l)%lambda_surf(m)         = building_pars(46,st) 
+                    surf_usm_v(l)%c_surface_green(m)     = building_pars(45,st)  
+                    surf_usm_v(l)%lambda_surf_green(m)   = building_pars(46,st) 
+                    surf_usm_v(l)%c_surface_window(m)    = building_pars(45,st)  
+                    surf_usm_v(l)%lambda_surf_window(m)  = building_pars(46,st) 
+
+
+                 ENDIF
+              ENDDO
+           ENDDO
+        ENDIF 
+
+!
+!--     Level 3 - initialization via building_pars read from file
+        IF ( building_pars_f%from_file )  THEN
+           DO  m = 1, surf_usm_h%ns
+              i = surf_usm_h%i(m)
+              j = surf_usm_h%j(m)
+
+!
+!--           In order to distinguish between ground floor level and 
+!--           above-ground-floor level surfaces, set input indices. 
+              ind_wall_frac    = MERGE( ind_wall_frac_gfl,    ind_wall_frac_agfl,    &
+                                        surf_usm_h%ground_level(m) )
+              ind_win_frac     = MERGE( ind_win_frac_gfl,     ind_win_frac_agfl,     &
+                                        surf_usm_h%ground_level(m) )
+              ind_green_frac_w = MERGE( ind_green_frac_w_gfl, ind_green_frac_w_agfl, &
+                                        surf_usm_h%ground_level(m) )
+              ind_green_frac_r = MERGE( ind_green_frac_r_gfl, ind_green_frac_r_agfl, &
+                                        surf_usm_h%ground_level(m) )
+              ind_lai_r        = MERGE( ind_lai_r_gfl,        ind_lai_r_agfl,        &
+                                        surf_usm_h%ground_level(m) )
+              ind_lai_w        = MERGE( ind_lai_w_gfl,        ind_lai_w_agfl,        &
+                                        surf_usm_h%ground_level(m) )
+              ind_hc1          = MERGE( ind_hc1_gfl,          ind_hc1_agfl,          &
+                                        surf_usm_h%ground_level(m) )
+              ind_hc2          = MERGE( ind_hc2_gfl,          ind_hc2_agfl,          &
+                                        surf_usm_h%ground_level(m) )
+              ind_hc3          = MERGE( ind_hc3_gfl,          ind_hc3_agfl,          &
+                                        surf_usm_h%ground_level(m) )
+              ind_tc1          = MERGE( ind_tc1_gfl,          ind_tc1_agfl,          &
+                                        surf_usm_h%ground_level(m) )
+              ind_tc2          = MERGE( ind_tc2_gfl,          ind_tc2_agfl,          &
+                                        surf_usm_h%ground_level(m) )
+              ind_tc3          = MERGE( ind_tc3_gfl,          ind_tc3_agfl,          &
+                                        surf_usm_h%ground_level(m) )
+              ind_emis_wall    = MERGE( ind_emis_wall_gfl,    ind_emis_wall_agfl,    &
+                                        surf_usm_h%ground_level(m) )
+              ind_emis_green   = MERGE( ind_emis_green_gfl,   ind_emis_green_agfl,   &
+                                        surf_usm_h%ground_level(m) )
+              ind_emis_win     = MERGE( ind_emis_win_gfl,     ind_emis_win_agfl,     &
+                                        surf_usm_h%ground_level(m) )
+              ind_trans        = MERGE( ind_trans_gfl,        ind_trans_agfl,        &
+                                        surf_usm_h%ground_level(m) )
+              ind_z0           = MERGE( ind_z0_gfl,           ind_z0_agfl,           &
+                                        surf_usm_h%ground_level(m) )
+              ind_z0qh         = MERGE( ind_z0qh_gfl,         ind_z0qh_agfl,         &
+                                        surf_usm_h%ground_level(m) )
+
+!
+!--           Initialize relatvie wall- (0), green- (1) and window (2) fractions
+              IF ( building_pars_f%pars_xy(ind_wall_frac,j,i) /= building_pars_f%fill )    &
+                 surf_usm_h%frac(0,m)  = building_pars_f%pars_xy(ind_wall_frac,j,i)   
+              IF ( building_pars_f%pars_xy(ind_green_frac_r,j,i) /= building_pars_f%fill ) & 
+                 surf_usm_h%frac(1,m)  = building_pars_f%pars_xy(ind_green_frac_r,j,i) 
+              IF ( building_pars_f%pars_xy(ind_win_frac,j,i) /= building_pars_f%fill )     & 
+                 surf_usm_h%frac(2,m)  = building_pars_f%pars_xy(ind_win_frac,j,i)
+
+ 
+              IF ( building_pars_f%pars_xy(ind_lai_r,j,i) /= building_pars_f%fill )        &
+                 surf_usm_h%lai(m)             = building_pars_f%pars_xy(ind_lai_r,j,i)
+
+              IF ( building_pars_f%pars_xy(ind_hc1,j,i) /= building_pars_f%fill )  THEN 
+                 surf_usm_h%rho_c_wall(nzb_wall,m)   = building_pars_f%pars_xy(ind_hc1,j,i)  
+                 surf_usm_h%rho_c_wall(nzb_wall+1,m) = building_pars_f%pars_xy(ind_hc1,j,i)
+              ENDIF
+              IF ( building_pars_f%pars_xy(ind_hc2,j,i) /= building_pars_f%fill )    &
+                 surf_usm_h%rho_c_wall(nzb_wall+2,m) = building_pars_f%pars_xy(ind_hc2,j,i)
+              IF ( building_pars_f%pars_xy(ind_hc3,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%rho_c_wall(nzb_wall+3,m) = building_pars_f%pars_xy(ind_hc3,j,i)
+              IF ( building_pars_f%pars_xy(ind_hc1,j,i) /= building_pars_f%fill )  THEN 
+                 surf_usm_h%rho_c_green(nzb_wall,m)   = building_pars_f%pars_xy(ind_hc1,j,i)  
+                 surf_usm_h%rho_c_green(nzb_wall+1,m) = building_pars_f%pars_xy(ind_hc1,j,i)
+              ENDIF
+              IF ( building_pars_f%pars_xy(ind_hc2,j,i) /= building_pars_f%fill )    &
+                 surf_usm_h%rho_c_green(nzb_wall+2,m) = building_pars_f%pars_xy(ind_hc2,j,i)
+              IF ( building_pars_f%pars_xy(ind_hc3,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%rho_c_green(nzb_wall+3,m) = building_pars_f%pars_xy(ind_hc3,j,i)
+              IF ( building_pars_f%pars_xy(ind_hc1,j,i) /= building_pars_f%fill )  THEN 
+                 surf_usm_h%rho_c_window(nzb_wall,m)   = building_pars_f%pars_xy(ind_hc1,j,i)  
+                 surf_usm_h%rho_c_window(nzb_wall+1,m) = building_pars_f%pars_xy(ind_hc1,j,i)
+              ENDIF
+              IF ( building_pars_f%pars_xy(ind_hc2,j,i) /= building_pars_f%fill )    &
+                 surf_usm_h%rho_c_window(nzb_wall+2,m) = building_pars_f%pars_xy(ind_hc2,j,i)
+              IF ( building_pars_f%pars_xy(ind_hc3,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%rho_c_window(nzb_wall+3,m) = building_pars_f%pars_xy(ind_hc3,j,i)
+
+              IF ( building_pars_f%pars_xy(ind_tc1,j,i) /= building_pars_f%fill )  THEN
+                 surf_usm_h%lambda_h(nzb_wall,m)   = building_pars_f%pars_xy(ind_tc1,j,i)         
+                 surf_usm_h%lambda_h(nzb_wall+1,m) = building_pars_f%pars_xy(ind_tc1,j,i)        
+              ENDIF
+              IF ( building_pars_f%pars_xy(ind_tc2,j,i) /= building_pars_f%fill )    &
+                 surf_usm_h%lambda_h(nzb_wall+2,m) = building_pars_f%pars_xy(ind_tc2,j,i)
+              IF ( building_pars_f%pars_xy(ind_tc3,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%lambda_h(nzb_wall+3,m) = building_pars_f%pars_xy(ind_tc3,j,i)    
+              IF ( building_pars_f%pars_xy(ind_tc1,j,i) /= building_pars_f%fill )  THEN
+                 surf_usm_h%lambda_h_green(nzb_wall,m)   = building_pars_f%pars_xy(ind_tc1,j,i)         
+                 surf_usm_h%lambda_h_green(nzb_wall+1,m) = building_pars_f%pars_xy(ind_tc1,j,i)        
+              ENDIF
+              IF ( building_pars_f%pars_xy(ind_tc2,j,i) /= building_pars_f%fill )    &
+                 surf_usm_h%lambda_h_green(nzb_wall+2,m) = building_pars_f%pars_xy(ind_tc2,j,i)
+              IF ( building_pars_f%pars_xy(ind_tc3,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%lambda_h_green(nzb_wall+3,m) = building_pars_f%pars_xy(ind_tc3,j,i)    
+              IF ( building_pars_f%pars_xy(ind_tc1,j,i) /= building_pars_f%fill )  THEN
+                 surf_usm_h%lambda_h_window(nzb_wall,m)   = building_pars_f%pars_xy(ind_tc1,j,i)         
+                 surf_usm_h%lambda_h_window(nzb_wall+1,m) = building_pars_f%pars_xy(ind_tc1,j,i)        
+              ENDIF
+              IF ( building_pars_f%pars_xy(ind_tc2,j,i) /= building_pars_f%fill )    &
+                 surf_usm_h%lambda_h_window(nzb_wall+2,m) = building_pars_f%pars_xy(ind_tc2,j,i)
+              IF ( building_pars_f%pars_xy(ind_tc3,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%lambda_h_window(nzb_wall+3,m) = building_pars_f%pars_xy(ind_tc3,j,i)    
+
+              IF ( building_pars_f%pars_xy(12,j,i) /= building_pars_f%fill )         & 
+                 surf_usm_h%target_temp_summer(m)  = building_pars_f%pars_xy(12,j,i)   
+              IF ( building_pars_f%pars_xy(13,j,i) /= building_pars_f%fill )         & 
+                 surf_usm_h%target_temp_winter(m)  = building_pars_f%pars_xy(13,j,i)   
+
+              IF ( building_pars_f%pars_xy(ind_emis_wall,j,i) /= building_pars_f%fill ) & 
+                 surf_usm_h%emissivity(0,m)        = building_pars_f%pars_xy(ind_emis_wall,j,i)
+              IF ( building_pars_f%pars_xy(ind_emis_green,j,i) /= building_pars_f%fill )& 
+                 surf_usm_h%emissivity(1,m)        = building_pars_f%pars_xy(ind_emis_green,j,i)
+              IF ( building_pars_f%pars_xy(ind_emis_win,j,i) /= building_pars_f%fill )  & 
+                 surf_usm_h%emissivity(2,m)        = building_pars_f%pars_xy(ind_emis_win,j,i)
+
+              IF ( building_pars_f%pars_xy(ind_trans,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%transmissivity(m)      = building_pars_f%pars_xy(ind_trans,j,i)
+
+              IF ( building_pars_f%pars_xy(ind_z0,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%z0(m)                  = building_pars_f%pars_xy(ind_z0,j,i)
+              IF ( building_pars_f%pars_xy(ind_z0qh,j,i) /= building_pars_f%fill )  & 
+                 surf_usm_h%z0h(m)                 = building_pars_f%pars_xy(ind_z0qh,j,i)
+              IF ( building_pars_f%pars_xy(ind_z0qh,j,i) /= building_pars_f%fill )  & 
+                 surf_usm_h%z0q(m)                 = building_pars_f%pars_xy(ind_z0qh,j,i)
+
+              IF ( building_pars_f%pars_xy(ind_alb_wall,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%albedo_type(0,m)       = building_pars_f%pars_xy(ind_alb_wall,j,i)
+              IF ( building_pars_f%pars_xy(ind_alb_green,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%albedo_type(1,m)       = building_pars_f%pars_xy(ind_alb_green,j,i)
+              IF ( building_pars_f%pars_xy(ind_alb_win,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%albedo_type(2,m)       = building_pars_f%pars_xy(ind_alb_win,j,i)
+
+              IF ( building_pars_f%pars_xy(ind_thick_1,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw(nzb_wall,m) = building_pars_f%pars_xy(ind_thick_1,j,i)
+              IF ( building_pars_f%pars_xy(ind_thick_2,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw(nzb_wall+1,m) = building_pars_f%pars_xy(ind_thick_2,j,i)
+              IF ( building_pars_f%pars_xy(ind_thick_3,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw(nzb_wall+2,m) = building_pars_f%pars_xy(ind_thick_3,j,i)
+              IF ( building_pars_f%pars_xy(ind_thick_4,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw(nzb_wall+3,m) = building_pars_f%pars_xy(ind_thick_4,j,i)
+              IF ( building_pars_f%pars_xy(ind_thick_1,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw_green(nzb_wall,m) = building_pars_f%pars_xy(ind_thick_1,j,i)
+              IF ( building_pars_f%pars_xy(ind_thick_2,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw_green(nzb_wall+1,m) = building_pars_f%pars_xy(ind_thick_2,j,i)
+              IF ( building_pars_f%pars_xy(ind_thick_3,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw_green(nzb_wall+2,m) = building_pars_f%pars_xy(ind_thick_3,j,i)
+              IF ( building_pars_f%pars_xy(ind_thick_4,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw_green(nzb_wall+3,m) = building_pars_f%pars_xy(ind_thick_4,j,i)
+              IF ( building_pars_f%pars_xy(ind_thick_1,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw_window(nzb_wall,m) = building_pars_f%pars_xy(ind_thick_1,j,i)
+              IF ( building_pars_f%pars_xy(ind_thick_2,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw_window(nzb_wall+1,m) = building_pars_f%pars_xy(ind_thick_2,j,i)
+              IF ( building_pars_f%pars_xy(ind_thick_3,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw_window(nzb_wall+2,m) = building_pars_f%pars_xy(ind_thick_3,j,i)
+              IF ( building_pars_f%pars_xy(ind_thick_4,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%zw_window(nzb_wall+3,m) = building_pars_f%pars_xy(ind_thick_4,j,i)
+
+              IF ( building_pars_f%pars_xy(45,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%c_surface(m)           = building_pars_f%pars_xy(45,j,i)
+              IF ( building_pars_f%pars_xy(46,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%lambda_surf(m)         = building_pars_f%pars_xy(46,j,i)
+              IF ( building_pars_f%pars_xy(45,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%c_surface_green(m)           = building_pars_f%pars_xy(45,j,i)
+              IF ( building_pars_f%pars_xy(46,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%lambda_surf_green(m)         = building_pars_f%pars_xy(46,j,i)
+              IF ( building_pars_f%pars_xy(45,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%c_surface_window(m)           = building_pars_f%pars_xy(45,j,i)
+              IF ( building_pars_f%pars_xy(46,j,i) /= building_pars_f%fill )    & 
+                 surf_usm_h%lambda_surf_window(m)         = building_pars_f%pars_xy(46,j,i)
+           ENDDO
+
+
+
+           DO  l = 0, 3
+              DO  m = 1, surf_usm_v(l)%ns
+                 i = surf_usm_v(l)%i(m) + surf_usm_v(l)%ioff
+                 j = surf_usm_v(l)%j(m) + surf_usm_v(l)%joff
+                
+!
+!--              In order to distinguish between ground floor level and 
+!--              above-ground-floor level surfaces, set input indices. 
+                 ind_wall_frac    = MERGE( ind_wall_frac_gfl,    ind_wall_frac_agfl,     &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_win_frac     = MERGE( ind_win_frac_gfl,     ind_win_frac_agfl,     &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_green_frac_w = MERGE( ind_green_frac_w_gfl, ind_green_frac_w_agfl, &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_green_frac_r = MERGE( ind_green_frac_r_gfl, ind_green_frac_r_agfl, &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_lai_r        = MERGE( ind_lai_r_gfl,        ind_lai_r_agfl,        &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_lai_w        = MERGE( ind_lai_w_gfl,        ind_lai_w_agfl,        &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_hc1          = MERGE( ind_hc1_gfl,          ind_hc1_agfl,          &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_hc2          = MERGE( ind_hc2_gfl,          ind_hc2_agfl,          &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_hc3          = MERGE( ind_hc3_gfl,          ind_hc3_agfl,          &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_tc1          = MERGE( ind_tc1_gfl,          ind_tc1_agfl,          &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_tc2          = MERGE( ind_tc2_gfl,          ind_tc2_agfl,          &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_tc3          = MERGE( ind_tc3_gfl,          ind_tc3_agfl,          &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_emis_wall    = MERGE( ind_emis_wall_gfl,    ind_emis_wall_agfl,    &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_emis_green   = MERGE( ind_emis_green_gfl,   ind_emis_green_agfl,   &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_emis_win     = MERGE( ind_emis_win_gfl,     ind_emis_win_agfl,     &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_trans        = MERGE( ind_trans_gfl,       ind_trans_agfl,         &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_z0           = MERGE( ind_z0_gfl,           ind_z0_agfl,           &
+                                           surf_usm_v(l)%ground_level(m) )
+                 ind_z0qh         = MERGE( ind_z0qh_gfl,         ind_z0qh_agfl,         &
+                                              surf_usm_v(l)%ground_level(m) )
+
+!
+!--              Initialize relatvie wall- (0), green- (1) and window (2) fractions
+                 IF ( building_pars_f%pars_xy(ind_wall_frac,j,i) /=                     &
+                      building_pars_f%fill )                                            &
+                    surf_usm_v(l)%frac(0,m)  = building_pars_f%pars_xy(ind_wall_frac,j,i)   
+                 IF ( building_pars_f%pars_xy(ind_green_frac_w,j,i) /=                  &
+                      building_pars_f%fill )                                            & 
+                    surf_usm_v(l)%frac(1,m)  = building_pars_f%pars_xy(ind_green_frac_w,j,i) 
+                 IF ( building_pars_f%pars_xy(ind_win_frac,j,i) /=                      &
+                      building_pars_f%fill )                                            & 
+                    surf_usm_v(l)%frac(2,m)  = building_pars_f%pars_xy(ind_win_frac,j,i)
+  
+                 IF ( building_pars_f%pars_xy(ind_lai_w,j,i) /= building_pars_f%fill )  & 
+                    surf_usm_v(l)%lai(m) = building_pars_f%pars_xy(ind_lai_w,j,i)
+
+                 IF ( building_pars_f%pars_xy(ind_hc1,j,i) /= building_pars_f%fill )    &
+                 THEN 
+                    surf_usm_v(l)%rho_c_wall(nzb_wall,m)   =                            &
+                                                    building_pars_f%pars_xy(ind_hc1,j,i)  
+                    surf_usm_v(l)%rho_c_wall(nzb_wall+1,m) =                            &
+                                                    building_pars_f%pars_xy(ind_hc1,j,i)
+                 ENDIF
+                 IF ( building_pars_f%pars_xy(ind_hc2,j,i) /= building_pars_f%fill )    &
+                    surf_usm_v(l)%rho_c_wall(nzb_wall+2,m) =                            &                            
+                                                    building_pars_f%pars_xy(ind_hc2,j,i)
+                 IF ( building_pars_f%pars_xy(ind_hc3,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%rho_c_wall(nzb_wall+3,m) =                            &
+                                                    building_pars_f%pars_xy(ind_hc3,j,i)
+                 IF ( building_pars_f%pars_xy(ind_hc1,j,i) /= building_pars_f%fill )  THEN 
+                    surf_usm_v(l)%rho_c_green(nzb_wall,m)   =                           &
+                                                    building_pars_f%pars_xy(ind_hc1,j,i)  
+                    surf_usm_v(l)%rho_c_green(nzb_wall+1,m) =                           &
+                                                    building_pars_f%pars_xy(ind_hc1,j,i)
+                 ENDIF
+                 IF ( building_pars_f%pars_xy(ind_hc2,j,i) /= building_pars_f%fill )    &
+                    surf_usm_v(l)%rho_c_green(nzb_wall+2,m) = building_pars_f%pars_xy(ind_hc2,j,i)
+                 IF ( building_pars_f%pars_xy(ind_hc3,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%rho_c_green(nzb_wall+3,m) = building_pars_f%pars_xy(ind_hc3,j,i)    
+                 IF ( building_pars_f%pars_xy(ind_hc1,j,i) /= building_pars_f%fill )  THEN 
+                    surf_usm_v(l)%rho_c_window(nzb_wall,m)   = building_pars_f%pars_xy(ind_hc1,j,i)  
+                    surf_usm_v(l)%rho_c_window(nzb_wall+1,m) = building_pars_f%pars_xy(ind_hc1,j,i)
+                 ENDIF
+                 IF ( building_pars_f%pars_xy(ind_hc2,j,i) /= building_pars_f%fill )    &
+                    surf_usm_v(l)%rho_c_window(nzb_wall+2,m) = building_pars_f%pars_xy(ind_hc2,j,i)
+                 IF ( building_pars_f%pars_xy(ind_hc3,j,i) /= building_pars_f%fill )    &
+                    surf_usm_v(l)%rho_c_window(nzb_wall+3,m) = building_pars_f%pars_xy(ind_hc3,j,i)
+
+                 IF ( building_pars_f%pars_xy(ind_tc1,j,i) /= building_pars_f%fill )  THEN
+                    surf_usm_v(l)%lambda_h(nzb_wall,m)   = building_pars_f%pars_xy(ind_tc1,j,i)         
+                    surf_usm_v(l)%lambda_h(nzb_wall+1,m) = building_pars_f%pars_xy(ind_tc1,j,i)        
+                 ENDIF
+                 IF ( building_pars_f%pars_xy(ind_tc2,j,i) /= building_pars_f%fill )    &
+                    surf_usm_v(l)%lambda_h(nzb_wall+2,m) = building_pars_f%pars_xy(ind_tc2,j,i)
+                 IF ( building_pars_f%pars_xy(ind_tc3,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%lambda_h(nzb_wall+3,m) = building_pars_f%pars_xy(ind_tc3,j,i)    
+                 IF ( building_pars_f%pars_xy(ind_tc1,j,i) /= building_pars_f%fill )  THEN
+                    surf_usm_v(l)%lambda_h_green(nzb_wall,m)   = building_pars_f%pars_xy(ind_tc1,j,i)         
+                    surf_usm_v(l)%lambda_h_green(nzb_wall+1,m) = building_pars_f%pars_xy(ind_tc1,j,i)        
+                 ENDIF
+                 IF ( building_pars_f%pars_xy(ind_tc2,j,i) /= building_pars_f%fill )    &
+                    surf_usm_v(l)%lambda_h_green(nzb_wall+2,m) = building_pars_f%pars_xy(ind_tc2,j,i)
+                 IF ( building_pars_f%pars_xy(ind_tc3,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%lambda_h_green(nzb_wall+3,m) = building_pars_f%pars_xy(ind_tc3,j,i)    
+                 IF ( building_pars_f%pars_xy(ind_tc1,j,i) /= building_pars_f%fill )  THEN
+                    surf_usm_v(l)%lambda_h_window(nzb_wall,m)   = building_pars_f%pars_xy(ind_tc1,j,i)         
+                    surf_usm_v(l)%lambda_h_window(nzb_wall+1,m) = building_pars_f%pars_xy(ind_tc1,j,i)        
+                 ENDIF
+                 IF ( building_pars_f%pars_xy(ind_tc2,j,i) /= building_pars_f%fill )    &
+                    surf_usm_v(l)%lambda_h_window(nzb_wall+2,m) = building_pars_f%pars_xy(ind_tc2,j,i)
+                 IF ( building_pars_f%pars_xy(ind_tc3,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%lambda_h_window(nzb_wall+3,m) = building_pars_f%pars_xy(ind_tc3,j,i)
+
+                 IF ( building_pars_f%pars_xy(12,j,i) /= building_pars_f%fill )         & 
+                    surf_usm_v(l)%target_temp_summer(m)  = building_pars_f%pars_xy(12,j,i)   
+                 IF ( building_pars_f%pars_xy(13,j,i) /= building_pars_f%fill )         & 
+                    surf_usm_v(l)%target_temp_winter(m)  = building_pars_f%pars_xy(13,j,i)   
+
+                 IF ( building_pars_f%pars_xy(ind_emis_wall,j,i) /= building_pars_f%fill ) & 
+                    surf_usm_v(l)%emissivity(0,m)        = building_pars_f%pars_xy(ind_emis_wall,j,i)
+                 IF ( building_pars_f%pars_xy(ind_emis_green,j,i) /= building_pars_f%fill )& 
+                    surf_usm_v(l)%emissivity(1,m)        = building_pars_f%pars_xy(ind_emis_green,j,i)
+                 IF ( building_pars_f%pars_xy(ind_emis_win,j,i) /= building_pars_f%fill )  & 
+                    surf_usm_v(l)%emissivity(2,m)        = building_pars_f%pars_xy(ind_emis_win,j,i)
+
+                 IF ( building_pars_f%pars_xy(ind_trans,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%transmissivity(m)      = building_pars_f%pars_xy(ind_trans,j,i)
+
+                 IF ( building_pars_f%pars_xy(ind_z0,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%z0(m)                  = building_pars_f%pars_xy(ind_z0,j,i)
+                 IF ( building_pars_f%pars_xy(ind_z0qh,j,i) /= building_pars_f%fill )  & 
+                    surf_usm_v(l)%z0h(m)                 = building_pars_f%pars_xy(ind_z0qh,j,i)
+                 IF ( building_pars_f%pars_xy(ind_z0qh,j,i) /= building_pars_f%fill )  & 
+                    surf_usm_v(l)%z0q(m)                 = building_pars_f%pars_xy(ind_z0qh,j,i)
+
+                 IF ( building_pars_f%pars_xy(ind_alb_wall,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%albedo_type(0,m)       = building_pars_f%pars_xy(ind_alb_wall,j,i)
+                 IF ( building_pars_f%pars_xy(ind_alb_green,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%albedo_type(1,m)       = building_pars_f%pars_xy(ind_alb_green,j,i)
+                 IF ( building_pars_f%pars_xy(ind_alb_win,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%albedo_type(2,m)       = building_pars_f%pars_xy(ind_alb_win,j,i)
+
+                 IF ( building_pars_f%pars_xy(ind_thick_1,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw(nzb_wall,m) = building_pars_f%pars_xy(ind_thick_1,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_2,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw(nzb_wall+1,m) = building_pars_f%pars_xy(ind_thick_2,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_3,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw(nzb_wall+2,m) = building_pars_f%pars_xy(ind_thick_3,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_4,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw(nzb_wall+3,m) = building_pars_f%pars_xy(ind_thick_4,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_1,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_green(nzb_wall,m) = building_pars_f%pars_xy(ind_thick_1,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_2,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_green(nzb_wall+1,m) = building_pars_f%pars_xy(ind_thick_2,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_3,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_green(nzb_wall+2,m) = building_pars_f%pars_xy(ind_thick_3,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_4,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_green(nzb_wall+3,m) = building_pars_f%pars_xy(ind_thick_4,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_1,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_window(nzb_wall,m) = building_pars_f%pars_xy(ind_thick_1,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_2,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_window(nzb_wall+1,m) = building_pars_f%pars_xy(ind_thick_2,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_3,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_window(nzb_wall+2,m) = building_pars_f%pars_xy(ind_thick_3,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_4,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_window(nzb_wall+3,m) = building_pars_f%pars_xy(ind_thick_4,j,i)
+
+                 IF ( building_pars_f%pars_xy(45,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%c_surface(m)           = building_pars_f%pars_xy(45,j,i)
+                 IF ( building_pars_f%pars_xy(46,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%lambda_surf(m)         = building_pars_f%pars_xy(46,j,i)
+                 IF ( building_pars_f%pars_xy(45,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%c_surface_green(m)     = building_pars_f%pars_xy(45,j,i)
+                 IF ( building_pars_f%pars_xy(46,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%lambda_surf_green(m)   = building_pars_f%pars_xy(46,j,i)
+                 IF ( building_pars_f%pars_xy(45,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%c_surface_window(m)    = building_pars_f%pars_xy(45,j,i)
+                 IF ( building_pars_f%pars_xy(46,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%lambda_surf_window(m)  = building_pars_f%pars_xy(46,j,i)
+
+              ENDDO
+           ENDDO
+        ENDIF 
+!       
+!--     Read the surface_types array.
+!--     Please note, here also initialization of surface attributes is done as
+!--     long as _urbsurf and _surfpar files are available. Values from above
+!--     will be overwritten. This might be removed later, but is still in the 
+!--     code to enable compatibility with older model version.
         CALL usm_read_urban_surface_types()
         
